// Video Tutorial
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 2, binding = 0, std140) uniform _220_222
{
    vec4 _m0;
    float _m1;
    float _m2;
    float _m3;
    float _m4;
    float _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10[3];
} _222;

layout(set = 1, binding = 0, std140) uniform _252_254
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    float _m3;
    int _m4;
    uint _m5;
    float _m6[1];
} _254;

layout(set = 0, binding = 2, std430) restrict readonly buffer _323_325
{
    vec4 _m0[];
} _325;

layout(set = 0, binding = 0, std140) uniform _376_378
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    float _m15;
    float _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    uint _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46[1];
} _378;

layout(set = 0, binding = 1, std140) uniform _705_707
{
    vec4 _m0[64];
} _707;

layout(set = 0, binding = 3) uniform sampler _710;
layout(set = 2, binding = 1) uniform texture2D _713;
layout(set = 2, binding = 2) uniform texture2D _714;
layout(set = 2, binding = 3) uniform texture2D _715;
layout(set = 2, binding = 4) uniform texture2D _716;

layout(location = 0, component = 0) in vec4 _211;
layout(location = 2, component = 0) out vec4 _642;
layout(location = 12, component = 0) in vec2 _645;
layout(location = 0, component = 0) out vec4 _697;
layout(location = 3, component = 0) in vec4 _698;
uint _46;
uint _48;
uint _50;
uint _52;
uint _54;
uint _56;
uint _58;
uint _59;
uint _61;
uint _62;
uint _64;
uint _66;
uint _68;
uint _70;
uint _72;
uint _74;
uint _76;
uint _78;
uint _80;

void _34(out uint _32, uint _33)
{
    _32 = 0u;
}

uint _29(uint _26, uint _27, uint _28)
{
    return (_26 + _27) + _28;
}

void _43(uint _37, uint _38, uint _39, uint _40, uint _41, uint _42)
{
}

mat4 _21(mat3x4 _19, mat4 _20)
{
    vec4 _87 = _20[0];
    vec4 _92 = _20[1];
    vec4 _96 = _20[2];
    vec4 _100 = _20[3];
    vec4 _104 = vec4(_19[0].x, _19[1].x, _19[2].x, 0.0);
    vec4 _114 = vec4(_19[0].y, _19[1].y, _19[2].y, 0.0);
    vec4 _123 = vec4(_19[0].z, _19[1].z, _19[2].z, 0.0);
    vec4 _132 = vec4(_19[0].w, _19[1].w, _19[2].w, 1.0);
    mat4 _142;
    _142[0] = vec4(dot(_87, _104), dot(_87, _114), dot(_87, _123), dot(_87, _132));
    _142[1] = vec4(dot(_92, _104), dot(_92, _114), dot(_92, _123), dot(_92, _132));
    _142[2] = vec4(dot(_96, _104), dot(_96, _114), dot(_96, _123), dot(_96, _132));
    _142[3] = vec4(dot(_100, _104), dot(_100, _114), dot(_100, _123), dot(_100, _132));
    return _142;
}

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

void main()
{
    _46 = 2147483648u;
    _48 = 1073741824u;
    _50 = 0u;
    _52 = 268435456u;
    _54 = 536870912u;
    _56 = 805306368u;
    _58 = 1073741824u;
    _59 = 1342177280u;
    _61 = 0u;
    _62 = 16777216u;
    _64 = 33554432u;
    _66 = 50331648u;
    _68 = 67108864u;
    _70 = 83886080u;
    _72 = 100663296u;
    _74 = 117440512u;
    _76 = 134217728u;
    _78 = 150994944u;
    _80 = 167772160u;
    vec4 _209;
    _209 = vec4(_211.xyz.x, _211.xyz.y, _211.xyz.z, _209.w);
    vec3 _218 = vec3(_222._m1, _222._m2, _222._m3);
    vec3 _231 = vec3(_222._m4, _222._m5, _222._m6);
    vec3 _247 = (_209.xyz * _218) + _231;
    _209 = vec4(_247.x, _247.y, _247.z, _209.w);
    _209.w = 1.0;
    vec4 _529;
    vec4 _532;
    vec4 _535;
    vec4 _538;
    if (_254._m3 > 0.0)
    {
        vec4 _268;
        vec4 _272;
        vec4 _275;
        if ((_254._m5 & 1u) != 0u)
        {
            _268 = _254._m0;
            _272 = _254._m1;
            _275 = _254._m2;
        }
        else
        {
            if (_254._m4 < 0)
            {
                uint _285;
                uint _286 = _285;
                uint _288 = 2u;
                _34(_286, _288);
                _285 = _286;
                uint _294 = _61;
                uint _296 = _56;
                uint _298 = _66 >> uint(24);
                uint _301 = _285;
                uint _303 = 0u;
                uint _304 = _29(_294, _296, _298);
                uint _305 = 1u;
                uint _306 = 2204079477u;
                uint _307 = 0u;
                _43(_301, _303, _304, _305, _306, _307);
                uint _314 = _285;
                uint _316 = 1u;
                uint _317 = uint(_254._m4);
                uint _318 = 0u;
                uint _319 = 62u;
                uint _320 = 64u;
                _43(_314, _316, _317, _318, _319, _320);
            }
            _268 = _325._m0[(_254._m4 * 4) + 0];
            _272 = _325._m0[(_254._m4 * 4) + 1];
            _275 = _325._m0[(_254._m4 * 4) + 2];
        }
        mat3x4 _345 = mat3x4(vec4(_268), vec4(_272), vec4(_275));
        vec3 _365 = vec3(_345[0].w, _345[1].w, _345[2].w);
        vec3 _373 = ((_365 - vec3(_378._m37, _378._m38, _378._m39)) * _378._m40) - vec3(_378._m41, _378._m42, _378._m43);
        _345[0].w = _373.x;
        _345[1].w = _373.y;
        _345[2].w = _373.z;
        mat4 _414 = mat4(vec4(_378._m3), vec4(_378._m4), vec4(_378._m5), vec4(_378._m6));
        if ((_254._m5 & 2u) != 0u)
        {
            _414 = mat4(vec4(_378._m7), vec4(_378._m8), vec4(_378._m9), vec4(_378._m10));
        }
        if ((_254._m5 & 4u) != 0u)
        {
            _414 = mat4(vec4(_378._m11), vec4(_378._m12), vec4(_378._m13), vec4(_378._m14));
        }
        mat3x4 _524 = _345;
        mat4 _526 = _414;
        mat4 _523 = _21(_524, _526);
        _529 = _523[0];
        _532 = _523[1];
        _535 = _523[2];
        _538 = _523[3];
    }
    else
    {
        if ((_254._m5 & 1u) != 0u)
        {
            _529 = _254._m0;
            _532 = _254._m1;
            _535 = _254._m2;
        }
        else
        {
            if (_254._m4 < 0)
            {
                uint _560;
                uint _561 = _560;
                uint _563 = 2u;
                _34(_561, _563);
                _560 = _561;
                uint _568 = _61;
                uint _570 = _56;
                uint _572 = _66 >> uint(24);
                uint _575 = _560;
                uint _577 = 0u;
                uint _578 = _29(_568, _570, _572);
                uint _579 = 257u;
                uint _580 = 2204079477u;
                uint _581 = 0u;
                _43(_575, _577, _578, _579, _580, _581);
                uint _586 = _560;
                uint _588 = 1u;
                uint _589 = uint(_254._m4);
                uint _590 = 0u;
                uint _591 = 62u;
                uint _592 = 64u;
                _43(_586, _588, _589, _590, _591, _592);
            }
            _529 = _325._m0[(_254._m4 * 4) + 0];
            _532 = _325._m0[(_254._m4 * 4) + 1];
            _535 = _325._m0[(_254._m4 * 4) + 2];
        }
        _538 = vec4(0.0, 0.0, 0.0, 1.0);
    }
    vec4 _616 = _209;
    vec4 _618 = _529;
    gl_Position.x = _12(_616, _618);
    vec4 _623 = _209;
    vec4 _625 = _532;
    gl_Position.y = _12(_623, _625);
    vec4 _629 = _209;
    vec4 _631 = _535;
    gl_Position.z = _12(_629, _631);
    vec4 _635 = _209;
    vec4 _637 = _538;
    gl_Position.w = _12(_635, _637);
    vec2 _654 = (_645 * _222._m0.zz) + _222._m0.xy;
    _642 = vec4(_654.x, _654.y, _642.z, _642.w);
    float _657 = _222._m7;
    if (_657 >= 1.0)
    {
        float _664 = _378._m44 / _222._m8;
        vec2 _672 = vec2(max(_664, 1.0), max(1.0 / _664, 1.0));
        if (_657 == 4.0)
        {
            _672 = vec2(_664, 1.0);
        }
        vec2 _694 = (_672 * (_642.xy - vec2(0.5))) + vec2(0.5);
        _642 = vec4(_694.x, _694.y, _642.z, _642.w);
    }
    _697 = _698;
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
gl_Position.x += vk3d_params[VIEW].stereo.x * vk3d_params[VIEW].custom_params.x;
}


