//UI
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 1, binding = 0, std140) uniform _271_273
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    float _m8;
    float _m9;
    int _m10;
    uint _m11;
} _273;

layout(set = 0, binding = 2, std430) restrict readonly buffer _351_353
{
    vec4 _m0[];
} _353;

layout(set = 0, binding = 0, std140) uniform _405_407
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    float _m15;
    float _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    uint _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44[3];
} _407;

layout(set = 2, binding = 0, std140) uniform _955_957
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    uint _m9;
    float _m10[3];
} _957;

layout(set = 0, binding = 1, std140) uniform _1017_1019
{
    vec4 _m0[64];
} _1019;

layout(push_constant, std430) uniform _971_973
{
    int _m0;
} _973;

layout(set = 3, binding = 0) uniform texture2D _1015[34816];
layout(set = 0, binding = 3) uniform sampler _1022;

layout(location = 0, component = 0) in vec4 _645;
layout(location = 2, component = 0) out vec4 _936;
layout(location = 12, component = 0) in vec2 _939;
layout(location = 3, component = 0) out vec4 _947;
layout(location = 0, component = 0) out vec4 _953;
layout(location = 3, component = 0) in vec4 _964;
uint _61;
uint _63;
uint _65;
uint _67;
uint _69;
uint _71;
uint _73;
uint _74;
uint _76;
uint _77;
uint _79;
uint _81;
uint _83;
uint _85;
uint _87;
uint _89;
uint _91;
uint _93;
uint _95;

void _49(out uint _47, uint _48)
{
    _47 = 0u;
}

uint _44(uint _41, uint _42, uint _43)
{
    return (_41 + _42) + _43;
}

void _58(uint _52, uint _53, uint _54, uint _55, uint _56, uint _57)
{
}

mat4 _36(mat3x4 _34, mat4 _35)
{
    vec4 _153 = _35[0];
    vec4 _158 = _35[1];
    vec4 _162 = _35[2];
    vec4 _166 = _35[3];
    vec4 _170 = vec4(_34[0].x, _34[1].x, _34[2].x, 0.0);
    vec4 _179 = vec4(_34[0].y, _34[1].y, _34[2].y, 0.0);
    vec4 _187 = vec4(_34[0].z, _34[1].z, _34[2].z, 0.0);
    vec4 _195 = vec4(_34[0].w, _34[1].w, _34[2].w, 1.0);
    mat4 _204;
    _204[0] = vec4(dot(_153, _170), dot(_153, _179), dot(_153, _187), dot(_153, _195));
    _204[1] = vec4(dot(_158, _170), dot(_158, _179), dot(_158, _187), dot(_158, _195));
    _204[2] = vec4(dot(_162, _170), dot(_162, _179), dot(_162, _187), dot(_162, _195));
    _204[3] = vec4(dot(_166, _170), dot(_166, _179), dot(_166, _187), dot(_166, _195));
    return _204;
}

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

float _17(float _16)
{
    float _106;
    if (_16 <= 0.040449999272823333740234375)
    {
        _106 = _16 / 12.9200000762939453125;
    }
    else
    {
        _106 = pow((_16 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
    return _106;
}

vec3 _23(vec3 _22)
{
    float _123 = _22.x;
    float _127 = _22.y;
    float _132 = _22.z;
    return vec3(_17(_123), _17(_127), _17(_132));
}

vec4 _27(vec4 _26)
{
    vec3 _140 = _26.xyz;
    return vec4(_23(_140), _26.w);
}

void main()
{
    _61 = 2147483648u;
    _63 = 1073741824u;
    _65 = 0u;
    _67 = 268435456u;
    _69 = 536870912u;
    _71 = 805306368u;
    _73 = 1073741824u;
    _74 = 1342177280u;
    _76 = 0u;
    _77 = 16777216u;
    _79 = 33554432u;
    _81 = 50331648u;
    _83 = 67108864u;
    _85 = 83886080u;
    _87 = 100663296u;
    _89 = 117440512u;
    _91 = 134217728u;
    _93 = 150994944u;
    _95 = 167772160u;
    if (_273._m8 == 0.0)
    {
        vec4 _556;
        vec4 _559;
        vec4 _562;
        vec4 _565;
        if (_273._m9 > 0.0)
        {
            vec4 _295;
            vec4 _299;
            vec4 _302;
            if ((_273._m11 & 1u) != 0u)
            {
                _295 = _273._m0;
                _299 = _273._m1;
                _302 = _273._m2;
            }
            else
            {
                if (_273._m10 < 0)
                {
                    uint _313;
                    uint _314 = _313;
                    uint _316 = 2u;
                    _49(_314, _316);
                    _313 = _314;
                    uint _322 = _76;
                    uint _324 = _71;
                    uint _326 = _81 >> uint(24);
                    uint _329 = _313;
                    uint _331 = 0u;
                    uint _332 = _44(_322, _324, _326);
                    uint _333 = 1u;
                    uint _334 = 1904082241u;
                    uint _335 = 0u;
                    _58(_329, _331, _332, _333, _334, _335);
                    uint _342 = _313;
                    uint _344 = 1u;
                    uint _345 = uint(_273._m10);
                    uint _346 = 0u;
                    uint _347 = 62u;
                    uint _348 = 64u;
                    _58(_342, _344, _345, _346, _347, _348);
                }
                _295 = _353._m0[(_273._m10 * 4) + 0];
                _299 = _353._m0[(_273._m10 * 4) + 1];
                _302 = _353._m0[(_273._m10 * 4) + 2];
            }
            mat3x4 _374 = mat3x4(vec4(_295), vec4(_299), vec4(_302));
            vec3 _394 = vec3(_374[0].w, _374[1].w, _374[2].w);
            vec3 _402 = ((_394 - vec3(_407._m37, _407._m38, _407._m39)) * _407._m40) - vec3(_407._m41, _407._m42, _407._m43);
            _374[0].w = _402.x;
            _374[1].w = _402.y;
            _374[2].w = _402.z;
            mat4 _443 = mat4(vec4(_407._m3), vec4(_407._m4), vec4(_407._m5), vec4(_407._m6));
            if ((_273._m11 & 2u) != 0u)
            {
                _443 = mat4(vec4(_407._m7), vec4(_407._m8), vec4(_407._m9), vec4(_407._m10));
            }
            if ((_273._m11 & 4u) != 0u)
            {
                _443 = mat4(vec4(_407._m11), vec4(_407._m12), vec4(_407._m13), vec4(_407._m14));
            }
            mat3x4 _551 = _374;
            mat4 _553 = _443;
            mat4 _550 = _36(_551, _553);
            _556 = _550[0];
            _559 = _550[1];
            _562 = _550[2];
            _565 = _550[3];
        }
        else
        {
            if ((_273._m11 & 1u) != 0u)
            {
                _556 = _273._m0;
                _559 = _273._m1;
                _562 = _273._m2;
            }
            else
            {
                if (_273._m10 < 0)
                {
                    uint _587;
                    uint _588 = _587;
                    uint _590 = 2u;
                    _49(_588, _590);
                    _587 = _588;
                    uint _595 = _76;
                    uint _597 = _71;
                    uint _599 = _81 >> uint(24);
                    uint _602 = _587;
                    uint _604 = 0u;
                    uint _605 = _44(_595, _597, _599);
                    uint _606 = 257u;
                    uint _607 = 1904082241u;
                    uint _608 = 0u;
                    _58(_602, _604, _605, _606, _607, _608);
                    uint _613 = _587;
                    uint _615 = 1u;
                    uint _616 = uint(_273._m10);
                    uint _617 = 0u;
                    uint _618 = 62u;
                    uint _619 = 64u;
                    _58(_613, _615, _616, _617, _618, _619);
                }
                _556 = _353._m0[(_273._m10 * 4) + 0];
                _559 = _353._m0[(_273._m10 * 4) + 1];
                _562 = _353._m0[(_273._m10 * 4) + 2];
            }
            _565 = vec4(0.0, 0.0, 0.0, 1.0);
        }
        vec4 _646 = _645;
        vec4 _648 = _556;
        gl_Position.x = _12(_646, _648);
        vec4 _653 = _645;
        vec4 _655 = _559;
        gl_Position.y = _12(_653, _655);
        vec4 _659 = _645;
        vec4 _661 = _562;
        gl_Position.z = _12(_659, _661);
        vec4 _665 = _645;
        vec4 _667 = _565;
        gl_Position.w = _12(_665, _667);
    }
    else
    {
        if (_273._m9 > 0.0)
        {
            mat3x4 _683;
            if ((_273._m11 & 1u) != 0u)
            {
                _683[0] = _273._m0;
                _683[1] = _273._m1;
                _683[2] = _273._m2;
            }
            else
            {
                if (_273._m10 < 0)
                {
                    uint _699;
                    uint _700 = _699;
                    uint _702 = 2u;
                    _49(_700, _702);
                    _699 = _700;
                    uint _707 = _76;
                    uint _709 = _71;
                    uint _711 = _81 >> uint(24);
                    uint _714 = _699;
                    uint _716 = 0u;
                    uint _717 = _44(_707, _709, _711);
                    uint _718 = 513u;
                    uint _719 = 1904082241u;
                    uint _720 = 0u;
                    _58(_714, _716, _717, _718, _719, _720);
                    uint _725 = _699;
                    uint _727 = 1u;
                    uint _728 = uint(_273._m10);
                    uint _729 = 0u;
                    uint _730 = 62u;
                    uint _731 = 64u;
                    _58(_725, _727, _728, _729, _730, _731);
                }
                _683[0] = _353._m0[(_273._m10 * 4) + 0];
                _683[1] = _353._m0[(_273._m10 * 4) + 1];
                _683[2] = _353._m0[(_273._m10 * 4) + 2];
            }
            mat4 _754 = mat4(vec4(_273._m3), vec4(_273._m4), vec4(_273._m5), vec4(_273._m6));
            mat3x4 _785 = _683;
            mat4 _787 = _754;
            mat4 _784 = _36(_785, _787);
            vec4 _790 = _645;
            vec4 _792 = _784[0];
            gl_Position.x = _12(_790, _792);
            vec4 _797 = _645;
            vec4 _799 = _784[1];
            gl_Position.y = _12(_797, _799);
            vec4 _804 = _645;
            vec4 _806 = _784[2];
            gl_Position.z = _12(_804, _806);
            vec4 _811 = _645;
            vec4 _813 = _784[3];
            gl_Position.w = _12(_811, _813);
        }
        else
        {
            vec4 _825;
            vec4 _828;
            vec4 _831;
            if ((_273._m11 & 1u) != 0u)
            {
                _825 = _273._m0;
                _828 = _273._m1;
                _831 = _273._m2;
            }
            else
            {
                if (_273._m10 < 0)
                {
                    uint _840;
                    uint _841 = _840;
                    uint _843 = 2u;
                    _49(_841, _843);
                    _840 = _841;
                    uint _848 = _76;
                    uint _850 = _71;
                    uint _852 = _81 >> uint(24);
                    uint _855 = _840;
                    uint _857 = 0u;
                    uint _858 = _44(_848, _850, _852);
                    uint _859 = 769u;
                    uint _860 = 1904082241u;
                    uint _861 = 0u;
                    _58(_855, _857, _858, _859, _860, _861);
                    uint _866 = _840;
                    uint _868 = 1u;
                    uint _869 = uint(_273._m10);
                    uint _870 = 0u;
                    uint _871 = 62u;
                    uint _872 = 64u;
                    _58(_866, _868, _869, _870, _871, _872);
                }
                _825 = _353._m0[(_273._m10 * 4) + 0];
                _828 = _353._m0[(_273._m10 * 4) + 1];
                _831 = _353._m0[(_273._m10 * 4) + 2];
            }
            vec4 _892 = vec4(0.0, 0.0, 0.0, 1.0);
            vec4 _893 = _645;
            vec4 _895 = _825;
            gl_Position.x = _12(_893, _895);
            vec4 _899 = _645;
            vec4 _901 = _828;
            gl_Position.y = _12(_899, _901);
            vec4 _905 = _645;
            vec4 _907 = _831;
            gl_Position.z = _12(_905, _907);
            vec4 _911 = _645;
            vec4 _913 = _892;
            gl_Position.w = _12(_911, _913);
        }
    }
    vec3 _917 = gl_Position.xyz - vec3(_407._m26, _407._m27, _407._m28);
    float _933 = length(_917);
    _936 = vec4(_939.x, _939.y, _933, 0.0);
    _947 = vec4(_939.x, _939.y, 0.0, 0.0);
    vec4 _961;
    if (_957._m0.x > 0.0)
    {
        vec4 _965 = _964;
        _961 = _27(_965);
    }
    else
    {
        _961 = _964;
    }
    _953 = _961;
    if (_973._m0 > 0)
    {
        vec2 _985 = _645.xy * _273._m7.xy;
        gl_Position = vec4(_985.x, _985.y, gl_Position.z, gl_Position.w);
        gl_Position.y = 1.0 - gl_Position.y;
        vec2 _999 = (gl_Position.xy * 2.0) - vec2(1.0);
        gl_Position = vec4(_999.x, _999.y, gl_Position.z, gl_Position.w);
        gl_Position = vec4(gl_Position.x, gl_Position.y, vec2(1.0).x, vec2(1.0).y);
    }
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
gl_Position.x += vk3d_params[VIEW].stereo.x * vk3d_params[VIEW].custom_params.x;
}


